var MODULE_NAME  = "Goto MACRO definition";
var MODULE_VER   = "1.0";
var MODULE_TITLE = "Searches for the definition of the selected macro name";

var ed;

function Init() {
    menuName = "&" + MODULE_NAME;
    subMenu = "&" + "DMIS";
    addMenuItem(menuName, subMenu, "main", "CTRL+SHIFT+D");
}


function main() 
{
	ed = newEditor();
	ed.assignActiveEditor();
	var srchMacroName = new String( ed.selText() );
	
	if ( srchMacroName.length < 1 )
	{
	   echo( 'No text selected! ' );
	   return false;
	}
	
	saveBeforeJumpPos( ed );
	
	var macDefFound = false;
   var macDefLine = 0;
   var macDefFile;
	var prjCount = projectFilesCount();
	var prjIdx = 0;
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	filesLoop :
	while ( prjIdx < prjCount )
	{
		 var prjFN = projectFiles( prjIdx );
		 prjIdx++;
		 try
		 {
		    var fs = fso.OpenTextFile( prjFN, 1, false);
		 }
		 catch ( e )
		 {
		    continue filesLoop;
		 }
		 var lnIdx = 0;
		 linesLoop :
		 while( !fs.AtEndOfStream )
		 {
		     var readline = fs.ReadLine();
		     readline = readline.replace( / /g, '' );
	        lnIdx++;
		     if ( readline.search( /^MACRO/i ) == -1 )
		     {
				  continue linesLoop;
			  }
			  var splitedline = readline.split( '/' );
			  var macroDefinition = splitedline[1];
			  var splitMacroDef =  macroDefinition.split( ',' );
			  var macroName = splitMacroDef[0]; 
			  if ( macroName == srchMacroName )
			  {
			  	  macDefLine = lnIdx;
			  	  macDefFound = true;
			  	  macDefFile = prjFN;
			  	  fs.Close();
			  	  break filesLoop;
			  }
		 }
		 fs.Close();
	}
	
	if ( macDefFound == false )
	{
	   echo( 'Definition of MACRO / ' + srchMacroName + ' not found in active project!' );
	   return false;
	}
	
	var edMacDefFile = getMacDefFile( macDefFile );
	setCaretToMacDef( edMacDefFile, macDefLine );
	return true;
}


function getMacDefFile( macDefFile )
{
     var mdfIsOpened = false;
     var macDefEditor = newEditor();
     
     OpenedEditorFiles :
     for ( var mdf = 0; mdf < editorsCount(); mdf++ )
     {
         var actEd = newEditor();
         actEd.assignEditorByIndex( mdf );
         var actEdFN = actEd.fileName();
         if ( actEdFN == macDefFile )
         {
			   mdfIsOpened = true;
			   break OpenedEditorFiles;
			}
	  }
	  if ( mdfIsOpened )
	  {
	     macDefEditor.assignEditorByName( macDefFile );
	  }
	  else
	  {
	     macDefEditor.openFile( macDefFile );
	  }
	  return macDefEditor;
}


function setCaretToMacDef( edMacDefFile, macDefLine )
{
    var fileText = edMacDefFile.text();
    var cary = 1;
    var newlinepos = 0;
    while ( cary < macDefLine )
    {
	     var newlinepos = fileText.indexOf( '\n', newlinepos );
	     newlinepos++;
	     cary++;
	 }
	 edMacDefFile.activate();
	 edMacDefFile.setCaretPos( 0, getNumOfLines( fileText ) );
	 edMacDefFile.setCaretPos( 0, cary );
}



function saveBeforeJumpPos( activeEditor )
{
    var activeFileName = activeEditor.fileName();
    var carx = activeEditor.caretX();
    var cary = activeEditor.caretY();
    var fso = new ActiveXObject("Scripting.FileSystemObject");
    var fs = fso.OpenTextFile( '../savedpos.txt', 8, true );
    fs.WriteLine( activeFileName + ',' + carx + ',' + cary );
    fs.Close();
}






function getNumOfLines( text )
{
   var nOfLns;
   var reg = new RegExp("\n","g");
	var mtch = text.match( reg );
	if ( mtch == null )
	{
 	   nOfLns = 1;
	}
	else
	{
 	   nOfLns = mtch.length;
	}
	return nOfLns;
}
