


function resize()
{
   window.resizeTo( 1000, 840 );
   window.moveTo( 50, 20 );
}


function load()
{
    resize();
    writeMacroName();
}

function writeMacroName()
{
   var cmd = DIG.commandLine;
   var name = cmd.split( ' ' )[1];

	getID( 'IDmacroname' ).innerText = 'MACRO / ' + name;
}

function trim( str )
{
    if ( !str )
       return str;
    while( str.substr( 0, 1 ) == " " )
    {
	    str = str.substr( 1, str.length -1 );
	 }
	 while( str.substr( str.length -1, 1 ) == " " )
	 {
	    str = str.substr( 0, str.length -1 );
	 }
	 return str;
}




function getID( IDname )
{
   return document.getElementById( IDname );
}

// scripts before confirming the dialog

function disableParamRange()
{
    getID( 'IDparamrangeFROM' ).disabled = true;
    getID( 'IDparamrangeTO' ).disabled = true;
}

function enableParamRange()
{
    getID( 'IDparamrangeFROM' ).disabled = false;
    getID( 'IDparamrangeTO' ).disabled = false;
}

function disableGlobalRange()
{
    getID( 'IDglobalrangeFROM' ).disabled = true;
    getID( 'IDglobalrangeTO' ).disabled = true;
}

function enableGlobalRange()
{
    getID( 'IDglobalrangeFROM' ).disabled = false;
    getID( 'IDglobalrangeTO' ).disabled = false;
}



function addParameter()
{
   var table = getID( 'IDtableparameters' );
   
   var type;
	if ( RADparamtype[0].checked )
	   type = 'Int';
	else if ( RADparamtype[1].checked )
	   type = 'Real';
	else
	   type = 'Char';
		
	var rangeFrom = 'unlimited', rangeTo = 'unlimited', range = ' ';
	if ( type != 'Char' )
	{
	   if ( getID( 'IDparamrangeFROM' ).value.length > 0 )
	   {
			rangeFrom = getID( 'IDparamrangeFROM' ).value;
	   	if ( isNaN( rangeFrom ) )
			   {
				   alert( 'Lower range bound incorrect!' );
				   return false;
				}

		}
	   if ( getID( 'IDparamrangeTO' ).value.length > 0 )
	   {
			rangeTo = getID( 'IDparamrangeTO' ).value;
		   if ( isNaN( rangeTo ) )
		   {
			   alert( 'Upper range bound incorrect!' );
			   return false;
			}
		}
		range = rangeFrom + ' : ' + rangeTo;
	}

	
	var description = getID( 'IDparameterdescription' ).value;
	if ( description.length < 1 )
	{
	   alert( 'Description not filled!' );
	   return false;
	}
	
	var newrow = table.insertRow();
	newrow.insertCell().innerText = type;
	newrow.insertCell().innerText = range;
	newrow.insertCell().innerText = description;
	
	getID( 'IDparamrangeFROM' ).value = '';
	getID( 'IDparamrangeTO' ).value = '';
	getID( 'IDparameterdescription' ).value = '';
	
}


function addGlobal()
{
   var table = getID( 'IDtableglobals' );
   
   var type;
	if ( RADglobaltype[0].checked )
	   type = 'Int';
	else if ( RADglobaltype[1].checked )
	   type = 'Real';
	else
	   type = 'Char';
		
	var rangeFrom = 'unlimited', rangeTo = 'unlimited', range = ' ';
	if ( type != 'Char' )
	{
	   if ( getID( 'IDglobalrangeFROM' ).value.length > 0 )
	   {
			rangeFrom = getID( 'IDglobalrangeFROM' ).value;
	   	if ( isNaN( rangeFrom ) )
			   {
				   alert( 'Lower range bound incorrect!' );
				   return false;
				}
		}
	   if ( getID( 'IDglobalrangeTO' ).value.length > 0 )
	   {
			rangeTo = getID( 'IDglobalrangeTO' ).value;
		   if ( isNaN( rangeTo ) )
		   {
			   alert( 'Upper range bound incorrect!' );
			   return false;
			}
		}
		range = rangeFrom + ' : ' + rangeTo;
	}
	
	var dir;
	if ( RADglobalDir[0].checked )
	{
	   dir = 'In';
	}
	else
	{
	   dir = 'Out';
	}
	
	var description = getID( 'IDglobaldescription' ).value;
	if ( description.length < 1 )
	{
	   alert( 'Description not filled!' );
	   return false;
	}
	
	var newrow = table.insertRow();
	newrow.insertCell().innerText = type;
	newrow.insertCell().innerText = range;
	newrow.insertCell().innerText = dir;
	newrow.insertCell().innerText = description;
	
	getID( 'IDglobalrangeFROM' ).value = '';
	getID( 'IDglobalrangeTO' ).value = '';
	getID( 'IDglobaldescription' ).value = '';
	
}

function readWarningLevel()
{
   var chck;
   var levels = new Array( 'Low', 'Medium', 'High' );
	for ( var i = 0; i < 3; i++ )
	{
	   if ( RADwarning[i].checked )
	      return ++i;
	}
	
	return 0;
}













function onOK()
{
   var xmlDoc = new ActiveXObject( 'Msxml2.DOMDocument.4.0' );
   
   var info = getID( 'IDinfo' ).value;
   var description = getID( 'IDdescription' ).value;
   var precondition = getID( 'IDprecondition' ).value;
   var warninglevel = readWarningLevel();
   var warningtext = getID( 'IDwarning' ).value;
   
   var version = getID( 'IDversion' ).value;
   var author = getID( 'IDauthor' ).value;
   
   // documentElement node
   var defNode = xmlDoc.createElement( 'doc' );
   defNode = xmlDoc.appendChild( defNode );
   
   // info node
   var infoNode = xmlDoc.createElement( 'info' );
   infoNode.text = info;
   defNode.appendChild( infoNode );
   
   // description node
   var descNode = xmlDoc.createElement( 'description' );
   descNode.text = description;
   defNode.appendChild( descNode );
   
   
   // parameters
	var tableparams = getID( 'IDtableparameters' );
   var paramcount = tableparams.tBodies[0].rows.length;

   if ( paramcount > 0 )
   {
	   for ( var row = 0; row < paramcount; row++ )
	   {
		   var paramNode = xmlDoc.createElement( 'param' );
		   
			var tr = tableparams.tBodies[0].rows[row];
		   var type = tr.cells[0].innerText;
		   
		   paramNode.setAttribute( 'type', type );
		   if ( type != 'Char' )
		   {
			   var range = tr.cells[1].innerText;
			   var newRange = ' ';
			   var splitrange = range.split( ':' );
// 			   alert( splitrange[0] + ' ' + splitrange[1] );
			   if ( trim(splitrange[0]) != 'unlimited' )
			   	newRange += trim(splitrange[0]);
		   	newRange += ':';
		   	if ( trim(splitrange[1]) != 'unlimited' )
		   		newRange += trim(splitrange[1]);
	   		newRange = trim(newRange);
	   		
	   		paramNode.setAttribute( 'range', newRange );
			}
   		
		   var desc = tr.cells[2].innerText;
		   paramNode.text = desc;
		   
		   defNode.appendChild( paramNode );
		}
	}
	
   
	// globals
	var tableglobals = getID( 'IDtableglobals' );
   var globalscount = tableglobals.tBodies[0].rows.length;
   if ( globalscount > 0 )
   {
	   for ( var row = 0; row < globalscount; row++ )
	   {
		   var globalNode = xmlDoc.createElement( 'global' );
		   
			var tr = tableglobals.tBodies[0].rows[row];
		   var type = tr.cells[0].innerText;
		   
		   globalNode.setAttribute( 'type', type );
		   if ( type != 'Char' )
			{
			   var range = tr.cells[1].innerText;
			   var newRange = ' ';
			   var splitrange = range.split( ':' );
			   if ( trim(splitrange[0]) != 'unlimited' )
			   	newRange += trim(splitrange[0]);
		   	newRange += ':';
		   	if ( trim(splitrange[1]) != 'unlimited' )
		   		newRange += trim(splitrange[1]);
	   		newRange = trim(newRange);
	   		
	   		globalNode.setAttribute( 'range', newRange );
			}		   

			var dir = tr.cells[2].innerText;
			globalNode.setAttribute( 'dir', dir );
			
		   var desc = tr.cells[3].innerText;
		   globalNode.text = desc;
		   
		   defNode.appendChild( globalNode );
		}
	}
	
	
   // preconditions node
   var precNode = xmlDoc.createElement( 'precondition' );
   precNode.text = precondition;
   defNode.appendChild( precNode );
   
   // warning node
   var warningNode = xmlDoc.createElement( 'warning' );
   warningNode.setAttribute( 'level', warninglevel );
   warningNode.text = warningtext;
   defNode.appendChild( warningNode );
	
	// version node
	var versionNode = xmlDoc.createElement( 'version' );
	versionNode.text = version;
	defNode.appendChild( versionNode );
	
	// author node
	var authorNode = xmlDoc.createElement( 'author' );
	authorNode.text = author;
	defNode.appendChild( authorNode );
		
	xmlDoc.save( 'c:/doc.xml' );
	
	window.close();
	
}







